
#ifndef _APP_H_
#define _APP_H_

#include "cam.h"
#include <gtk/gtkgl.h>

typedef struct _Cnc2D Cnc2D;
struct _Cnc2D
{
	GtkWidget *window;
	GladeXML *xml;
	gchar *filename;
	GdkDrawable *draw_area;
	GtkWidget *draw_widget;
	GdkGC *gc;
	GtkWidget *filedialog;
	GtkWidget *filesavedialog;
	GtkStatusbar *statusbar;
	gchar *infotext;
	gint progress;
	GtkFileFilter *img_filter;
	GtkFileFilter *img_filter2;
	GdkGLConfig *glconfig;
	CAM__HeightMap *HeightMapSource;
	CAM__HeightMap *HeightMapView;
	CamSetup *CamSet;
	GMutex *ViewMutex;
	GtkWidget *gl_area;
	GdkGLConfig *gl_config;
	gchar gl_mode;
	gfloat gl_zoom;
	gfloat gl_zzoom;
	gfloat hm_zoom;
	gboolean redraw;
};
Cnc2D *app;

Cnc2D *app__new (void);
void app__view_redraw(void);
void app__showmap(CAM__HeightMap *HeightMap);
void app__set_infobar (gchar *text_str);
void app__set_progress (gint percent);
void app__set_sizeinfo (void);
void app__load_file (gchar *filename, gint z_stop, gint z_start, gboolean use_rg, gboolean invert);
void app__show_error (gchar *title_str, gchar *text_str);
void app__show_info (gchar *title_str, gchar *text_str);

#endif
