
#ifndef _CAM_H_
#define _CAM_H_

#include "cam_setup.h"

typedef struct _CAM__HeightMap CAM__HeightMap;
struct _CAM__HeightMap {
	gboolean use_rg;
	gint width;
	gint height;
	gint *data;
};

gdouble CAM__GetTotalMapSize(void);
gint CAM__GetTotalMapNum(void);
gint CAM__HeightMap_CNC_Liner(CAM__HeightMap *HeightMap, gint min_x, gint min_y, gint max_x, gint max_y, CamSetup *CamSet);
gint CAM__HeightMap_CNC_Soft3D(CAM__HeightMap *HeightMap, CamSetup *CamSet);
gint CAM__HeightMap_CNC_Fill(CAM__HeightMap *HeightMap, CamSetup *CamSet);
gint CAM__HeightMap_CheckCircle(CAM__HeightMap *HeightMap, gint x0, gint y0, gint radius2, gint radius1);
gint CAM__HeightMap_CheckCircleMin(CAM__HeightMap *HeightMap, gint x0, gint y0, gint radius_max);
gint CAM__HeightMap_CheckCircleMax(CAM__HeightMap *HeightMap, gint x0, gint y0, gint radius_max);
gint CAM__HeightMap_CheckPixel(CAM__HeightMap *HeightMap, gint x, gint y);
CAM__HeightMap *CAM__HeightMap_Copy(CAM__HeightMap *HeightMap);
CAM__HeightMap *CAM__HeightMap_AddFrame(CAM__HeightMap *HeightMap, gint width);
CAM__HeightMap *CAM__HeightMap_DepthCopy(CAM__HeightMap *HeightMap, gint depth);
CAM__HeightMap *CAM__HeightMap_Contour(CAM__HeightMap *HeightMap, CamSetup *CamSet);
CAM__HeightMap *CAM__HeightMap_Outline(CAM__HeightMap *HeightMap, CamSetup *CamSet);
CAM__HeightMap *CAM__HeightMap_Fill(CAM__HeightMap *HeightMap, CamSetup *CamSet);
CAM__HeightMap *CAM__HeightMap_create (gint width, gint height);
void CAM__Heightmap_delete(CAM__HeightMap *HeightMap);
void CAM__HeightMap_Invert(CAM__HeightMap *HeightMap);
void CAM__HeightMap_DrawGL(CAM__HeightMap *HeightMap, gchar mode);

#endif
