
#ifndef _CAM_SETUP_H_
#define _CAM_SETUP_H_

#define CAMSETUP__OK GTK_RESPONSE_OK

//! Struct of a CNC-Tool-Head
typedef struct _CamSetup_Head CamSetup_Head;
struct _CamSetup_Head {
	gint radius;		// Radius des Stiftes/Bohrkopfes
	gint speed;			// Maximaler Vorschub
	gint type;			// Typ des Stiftes/Bohrkopfes
	gchar image[1024];	// Bild des Stiftes/Bohrkopfes (ca 20x100)
};

//! Struct of a CNC-Tool
typedef struct _CamSetup_Tool CamSetup_Tool;
struct _CamSetup_Tool {
	gint speed;		// Drehzahl des Bohrkopfes
	gint delay;		// Wartezeit nach anschalten des Stiftes/Bohrkopfes
	gint type;		// Typ des Werkzeugs (0=Stift, 1=Bohr-Motor)
	CamSetup_Head head;
};

//! Struct of a generic CNC-Axis
typedef struct _CamSetup_Axis CamSetup_Axis;
struct _CamSetup_Axis {
	gint speed;
	gint type;
};

//! Struct of a CNC-Tool-Axis
typedef struct _CamSetup_ToolAxis CamSetup_ToolAxis;
struct _CamSetup_ToolAxis {
	gint speed;		// Achsen-Speed
	gint type;		// Typ des Achen-Antriebs (0=Stepper, 1=Servo)
	CamSetup_Tool tool;
};

//! Struct of a CNC-Material
typedef struct _CamSetup_Material CamSetup_Material;
struct _CamSetup_Material {
	gchar name[64];
	gint speed;
	gint m_speed;
	gint z_steps;
};

//! Struct of the Cam-Setup
typedef struct _CamSetup CamSetup;
struct _CamSetup {
	CamSetup_Material camsetup__material[10];
	CamSetup_Axis axis_x[2];
	CamSetup_Axis axis_y[2];
	CamSetup_ToolAxis axis_z[3];
	GtkWidget *window;
	GladeXML *xml;
	gint tool;
	gint z_start;
	gint z_stop;
	gint z_over;
	gint z_step;
	gint z_steps;
	gint output;
	gfloat zoom;
	gint material;
};


CamSetup *camsetup__init ();
void camsetup__show (void);
void camsetup__hide (void);
void camsetup__values_default (void);
void camsetup__values_set (void);
void camsetup__values_get (void);
gint camsetup__run (gchar *title_str);

#endif
