/*
	Danke an Wikipedia fuer den Bresenham-Algorithmus.
*/

#include <linux/list.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <mntent.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>
#include <stdio.h>
#include <string.h> 

#include "../gui/sdl.h"
#include "../gui/gui.h"
#include "../frontend.h"

#include "cnc-struct.c"
#include "cnc-interface.h"
#include "cnc-interface.c"
#include "cnc_2d_liner.c"
#include "cnc_2d_outliner.c"
#include "cnc_2d_fill.c"
#include "cnc_2d_fill_objects.c"
#include "cnc_2d_drill.c"

int cnc_check_pixel(unsigned char *img_data, int width, int x, int y) {
    if (img_data[(y * width) + x] == IMG_DATA_MARK1) {
	    return 0;
    } else {
	    return 1;
    }
}

int cnc_check_circle_bresenham(unsigned char *img_data, int width, int x0, int y0, int radius2, int radius1) {
	int f;
	int ddF_x;
	int ddF_y;
	int x;
	int y;
	int radius;
	for (radius = radius2; radius >= radius1; radius--) {
		f = 1 - radius;
		ddF_x = 0;
		ddF_y = -2 * radius;
		x = 0;
		y = radius;
		if (img_data[((y0 + radius) * width) + x0] == IMG_DATA_MARK1) {
			return 1;
		}
		if (img_data[((y0 - radius) * width) + x0] == IMG_DATA_MARK1) {
			return 1;
		}
		if (img_data[(y0 * width) + (x0 + radius)] == IMG_DATA_MARK1) {
			return 1;
		}
		if (img_data[(y0 * width) + (x0 - radius)] == IMG_DATA_MARK1) {
			return 1;
		}
		while(x < y) {
			if(f >= 0) {
				y--;
				ddF_y += 2;
				f += ddF_y;
			}
			x++;
			ddF_x += 2;
			f += ddF_x + 1;
			if (img_data[((y0 + y) * width) + (x0 + x)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y0 + y) * width) + (x0 - x)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y0 - y) * width) + (x0 + x)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y0 - y) * width) + (x0 - x)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y0 + x) * width) + (x0 + y)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y0 + x) * width) + (x0 - y)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y0 - x) * width) + (x0 + y)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y0 - x) * width) + (x0 - y)] == IMG_DATA_MARK1) {
				return 1;
			}
		}
	}
	return 0;
}


int cnc_check_circle(unsigned char *img_data, int width, int x, int y, int size, int size2) {
	int px = 0;
	int py = 0;
	int lpx = 0;
	int lpy = 0;
	int n_s = 0;
	float winkel = 0;
	for (n_s = size; n_s >= size2; n_s--) {
// 		for(winkel = 0; winkel < 0.78; winkel += 0.03) {
		for(winkel = 0; winkel <= 0.72; winkel += 0.16) {
			px = (int)((float)n_s * cos(winkel));
			py = (int)((float)n_s * sin(winkel));
			if (lpx == px && lpy == py) {
				continue;
			}
			if (img_data[((y + py) * width) + (x + px)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y + px) * width) + (x + py)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y - py) * width) + (x - px)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y - px) * width) + (x - py)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y + py) * width) + (x - px)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y + px) * width) + (x - py)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y - py) * width) + (x + px)] == IMG_DATA_MARK1) {
				return 1;
			}
			if (img_data[((y - px) * width) + (x + py)] == IMG_DATA_MARK1) {
				return 1;
			}
			lpx = px;
			lpy = py;
		}
	}
        return 0;
}
