
#ifndef _CNC_OUTPUT_H_
#define _CNC_OUTPUT_H_

#define MY_PI 3.141592653589793

typedef struct _CncConfig_Output CncConfig_Output;
struct _CncConfig_Output {
	void *plugin;
	gint (*cb_get_offset_z) (gint tool_id);
	gint (*cb_set_offset_z) (gint tool_id, gint offset);
	gint (*cb_check_z) (void);
	gint (*cb_check_size) (void);
	gint (*cb_set_speed_xy) (gint speed);
	gint (*cb_set_speed_z) (gint speed);
	gint (*cb_reset) (void);
	gint (*cb_start) (gint x, gint y, gint z, gint r);
	gint (*cb_stop) (void);
	gint (*cb_off) (void);
	gint (*cb_tool_change) (gint tool_nr);
	gint (*cb_go_xy) (gint x, gint y);
	gint (*cb_go_xyz) (gint x, gint y, gint z);
	gint (*cb_go_x) (gint x);
	gint (*cb_go_y) (gint y);
	gint (*cb_go_z) (gint z);
	gint (*cb_soft_start) (gint value);
	gint (*cb_drill_on) (void);
	gint (*cb_drill_off) (void);
	gint (*cb_drill_set_speed) (gint speed);
	gint (*cb_drill) (void);
	gint (*cb_pen) (gint updown);
	gint (*cb_init) (void);
	gint (*cb_cfgfe_show) (void);
	gint (*cb_cfgfe_hide) (void);
	gint cfgfe;
	gchar name[128];
};

CncConfig_Output CNC__Out[10];
gint CNC__OutID;
gint CNC__OutMaxID;
gint CNC__OutActive;
gfloat CNC__OutZoom_X;
gfloat CNC__OutZoom_Y;
gfloat CNC__OutZoom_Z;

gint CNC__Init(void);
void CNC__Halt(void);
gint CNC__Active(void);
gint CNC__Start(gint x, gint y, gint z, gint r);
gint CNC__Stop(void);
gint CNC__Reset(void);
gint CNC__Off(void);
gint CNC__Go_XY(gint x, gint y);
gint CNC__Go_XYZ(gint x, gint y, gint z);
gint CNC__Go_X(gint x);
gint CNC__Go_Y(gint y);
gint CNC__Go_Z(gint z);
gint CNC__DrillOn(void);
gint CNC__DrillOff(void);
gint CNC__DrillSetSpeed(gint speed);
gint CNC__Drill(void);
gint CNC__Pen(gint updown);
gint CNC__SpeedXY(gint speed);
gint CNC__SpeedZ(gint speed);
gint CNC__CheckZ(void);
gint CNC__Get_OffsetZ(gint plugin_id, gint tool_id);
gint CNC__Set_OffsetZ(gint plugin_id, gint tool_id, gint offset);
gint CNC__CeckSize(void);
gint CNC__ToolChange(gint tool_nr);
gint CNC__SoftStart(gint value);
gint CNC__SetOutput(gint output_id);
gint CNC__SetZoom_X(gfloat zoom);
gint CNC__SetZoom_Y(gfloat zoom);
gint CNC__SetZoom_Z(gfloat zoom);
gint CNC__SetZoom(gfloat zoom);
gint CNC__CfgFe_Show(gint plugin_id);
gint CNC__CfgFe_Hide(gint plugin_id);
gint CNC__CfgFe_Support(gint plugin_id);

#endif
