/***************************************************************************
 *            draw.h
 *
 *  Tue Mar 21 22:10:32 2006
 *  Copyright  2006  Oliver ‬Dippel
 *  o.dippel@gmx.de
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gnome.h>


typedef struct {
	gboolean fill;
	gint mode;
	gint tool;
	gint color_mode;
	GdkColor fgcolor;
	GdkColor bgcolor;
	GdkFont *font;
	gchar fontname[1024];
	gchar text[1024];
	GnomeCanvasPoints *canvas_points;
	GnomeCanvasItem *active_item;
	GnomeCanvasGroup *active_group;
	void (*tool_add_cb[15])(GtkWidget *widget, gint x, gint y);
	void (*tool_move_cb[15])(GtkWidget *widget, gint x, gint y);
	void (*tool_scale_cb[15])(GtkWidget *widget, gint x, gint y);
} DrawingData;
DrawingData drawdata;


void draw_start(GtkWidget *widget, gint x, gint y);
void draw_motion(GtkWidget *widget, gint x, gint y);
void draw_stop(GtkWidget *widget, gint x, gint y);
void draw_tool_select(gint tool);
void draw_init(void);
void draw_tooloption_fill(void);
void draw_convert_hm_to_3d(void);
