/** \file main.c
 *  \brief Main-File.
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <libgnomevfs/gnome-vfs.h>
#include <gnome.h>
#include <gtk/gtkgl.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <glade/glade.h>

#include "app.h"
#include "draw.h"
#include "cam_setup.h"
#include "cam.h"
#include "cam_imgload.h"
#include "cnc_output.h"
#include "cam_object.h"

extern void gl__window_new (void);


gint ProgressCallback (GnomeVFSXferProgressInfo *info, gpointer data) {
	fprintf(stderr, "## Callback ##\n");
	return 0;
}





//! Main-Loop
int main (int argc, char *argv[]) {
	#ifdef ENABLE_NLS
		bindtextdomain(GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
		textdomain(PACKAGE);
	#endif

	gnome_init(PACKAGE, VERSION, argc, argv);
	gtk_gl_init(&argc, &argv);
	glade_gnome_init();

	if (!g_thread_supported ()) {
		g_thread_init (NULL);
	}

	app = app__new();
	app__set_infobar(_("loading CNC-Library"));
	if (argc > 1 && argv[1][0] != 0) {
		if (strstr(argv[1], ".plt\0") != 0 || strstr(argv[1], ".hpgl\0") != 0) {
//			on_tools_2dimport_activate(NULL, NULL);
		} else if (strstr(argv[1], ".dxf\0") != 0) {
//			on_tools_3dimport_activate(NULL, NULL);
		} else if (strstr(argv[1], ".3ds\0") != 0) {
//			on_tools_3dimport_activate(NULL, NULL);
		} else {
/*
			  if (gnome_vfs_init()) {
				  GnomeVFSURI *SourceURI = gnome_vfs_uri_new("file:///tmp/test.bmp");
				  GnomeVFSURI *TargetURI = gnome_vfs_uri_new("file:///tmp/temp.bmp");
				  gnome_vfs_xfer_uri(SourceURI,	TargetURI, GNOME_VFS_XFER_LINK_ITEMS, GNOME_VFS_XFER_ERROR_MODE_ABORT, GNOME_VFS_XFER_OVERWRITE_MODE_REPLACE, ProgressCallback, NULL);
			  }
*/
			app__load_file(argv[1], 0, 2000, FALSE, FALSE);
		}
	} else {
		app__set_infobar(_("Please load a Heightmap"));
	}

	gl__window_new();

	draw_init();

	gtk_main();

	CAM__Heightmap_delete(app->HeightMapView);
	CAM__Heightmap_delete(app->HeightMapSource);

	return 0;
}
