
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <mntent.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>
#include <stdio.h>
#include <string.h> 
#include <dirent.h>
#include <dlfcn.h>

#include "config.h"

int cnc_last_updown = 0;
int cnc_last_x = 0;
int cnc_last_y = 0;
int cnc_last_z = 0;
int cnc_speed_default = 100;
int cnc_speed_xy = 100;
int cnc_speed_z = 100;
int drill_speed_last = -1;

int prog_num = 0;
FILE *cncout_plugin_stream = NULL;

int cncout_plugin_check_z(void) {
	fprintf(cncout_plugin_stream, "(CNC-Check Z)\n");
	fprintf(cncout_plugin_stream, "(--------------------------)\n");
	return 0;
}

int cncout_plugin_check_size(void) {
	fprintf(cncout_plugin_stream, "(CNC-Check Size)\n");
	fprintf(cncout_plugin_stream, "(--------------------------)\n");
	return 0;
}

int cncout_plugin_set_speed_xy(int speed) {
	cnc_speed_xy = speed;
	return 0;
}

int cncout_plugin_set_speed_z(int speed) {
	cnc_speed_z = speed;
	return 0;
}

int cncout_plugin_soft_start(int value) {
	fprintf(cncout_plugin_stream, "(CNC-Softstart: %i)\n", value);
	fprintf(cncout_plugin_stream, "(--------------------------)\n");
	return 0;
}

int cncout_plugin_reset(void) {
	fprintf(cncout_plugin_stream, "(CNC-Reset)\n");
	fprintf(cncout_plugin_stream, "(--------------------------)\n");
	fprintf(cncout_plugin_stream, "N%i G01 Z100.0 F%i\n", prog_num++, cnc_speed_xy);
	if (drill_speed_last != 0) {
		fprintf(cncout_plugin_stream, "N%i M5\n", prog_num++);
	}
	fprintf(cncout_plugin_stream, "N%i G00 X0.0 Y0.0\n", prog_num++);
	cnc_speed_xy = cnc_speed_default;
	cnc_speed_z = cnc_speed_default;
	cnc_last_z = 10000;
	drill_speed_last = 0;
	return 0;
}

int cncout_plugin_start(int x, int y, int z, int r) {
	if ((cncout_plugin_stream = fopen("/tmp/cnc_gcode-output.cnc", "w")) != 0) {
		down_pos = z;
		prog_num = 0;
		fprintf(cncout_plugin_stream, "($SetPartSize(%0.2f,%0.2f,%0.2f,1))\n", (float)x / 100.0, (float)y / 100.0, (float)z / 100.0);
		fprintf(cncout_plugin_stream, "($SetRadiusPrg(0))\n");
		fprintf(cncout_plugin_stream, "(--------------------------)\n");
		fprintf(cncout_plugin_stream, "(generated by mXm-CAM)\n");
		fprintf(cncout_plugin_stream, "(all values in mm)\n");
		fprintf(cncout_plugin_stream, "(Size X,Y,Z : %0.2f,%0.2f,%0.2f)\n", (float)x / 100.0, (float)y / 100.0, (float)z / 100.0);
		fprintf(cncout_plugin_stream, "(Tool-Radius: %0.2f)\n", (float)r / 100.0);
		fprintf(cncout_plugin_stream, "(--------------------------)\n");
		fprintf(cncout_plugin_stream, "(CNC-Start)\n");
		fprintf(cncout_plugin_stream, "(--------------------------)\n");
		fprintf(cncout_plugin_stream, "%%1\n");
		fprintf(cncout_plugin_stream, "N%i G90\n", prog_num++);
		fprintf(cncout_plugin_stream, "N%i G96\n", prog_num++);
		cncout_plugin_reset();
	} else {
		cncout_plugin_stream = NULL;
	}
	return 0;
}

int cncout_plugin_stop(void) {
	fprintf(cncout_plugin_stream, "(CNC-Stop)\n");
	fprintf(cncout_plugin_stream, "(--------------------------)\n");
	fprintf(cncout_plugin_stream, "N%i G01 Z100.0 F%i\n", prog_num++, cnc_speed_z);
	if (drill_speed_last != 0) {
		fprintf(cncout_plugin_stream, "N%i M5\n", prog_num++);
		drill_speed_last = 0;
	}
	fprintf(cncout_plugin_stream, "N%i G00 X0.0 Y0.0\n", prog_num++);
	fprintf(cncout_plugin_stream, "N%i M30\n", prog_num++);
	fprintf(cncout_plugin_stream, "\n");
	if (cncout_plugin_stream != NULL) {
		fclose(cncout_plugin_stream);
	}
	return 0;
}

int cncout_plugin_off(void) {
	fprintf(cncout_plugin_stream, "(CNC-Off)\n");
	fprintf(cncout_plugin_stream, "(--------------------------)\n");
	if (drill_speed_last != 0) {
		fprintf(cncout_plugin_stream, "N%i M5\n", prog_num++);
		drill_speed_last = 0;
	}
	return 0;
}

int cncout_plugin_tool_change(int tool_nr) {
	fprintf(cncout_plugin_stream, "(CNC-Toolchange)\n");
	fprintf(cncout_plugin_stream, "(--------------------------)\n");
	fprintf(cncout_plugin_stream, "N%i G01 Z100.0 F%i\n", prog_num++, cnc_speed_z);
	fprintf(cncout_plugin_stream, "N%i M5\n", prog_num++);
	fprintf(cncout_plugin_stream, "N%i G00 X0.0 Y0.0\n", prog_num++);
	fprintf(cncout_plugin_stream, "N%i M06 T%i\n", prog_num++, tool_nr);
	fprintf(cncout_plugin_stream, "N%i G01 Z100.0 F%i\n", prog_num++, cnc_speed_z);
	fprintf(cncout_plugin_stream, "N%i M5\n", prog_num++);
	fprintf(cncout_plugin_stream, "N%i G00 X0.0 Y0.0\n", prog_num++);
	drill_speed_last = 0;
	return 0;
}

int cncout_plugin_go_xy(int x, int y) {
	if (cnc_last_x != x || cnc_last_y != y) {
		if (cnc_last_z < down_pos) {
			//F = Vorschub-Speed (mm/sec)
			fprintf(cncout_plugin_stream, "N%i G01 X%0.2f Y%0.2f F%i\n", prog_num++, (float)x / 100.0, (float)y / 100.0, cnc_speed_xy);
		} else {
			fprintf(cncout_plugin_stream, "N%i G00 X%0.2f Y%0.2f\n", prog_num++, (float)x / 100.0, (float)y / 100.0);
		}
	}
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_xyz(int x, int y, int z) {
	if (cnc_last_x != x || cnc_last_y != y || cnc_last_z != z) {
		if (cnc_last_z < down_pos || z < down_pos) {
			fprintf(cncout_plugin_stream, "N%i G01 X%0.2f Y%0.2f Z%0.2f F%i\n", prog_num++, (float)x / 100.0, (float)y / 100.0, (float)(z - down_pos) / 100.0, cnc_speed_xy);
		} else {
			fprintf(cncout_plugin_stream, "N%i G00 X%0.2f Y%0.2f Z%0.2f\n", prog_num++, (float)x / 100.0, (float)y / 100.0, (float)(-z) / 100.0);
		}
	}
	cnc_last_y = y;
	cnc_last_x = x;
	cnc_last_z = z;
	return 0;
}

int cncout_plugin_go_x(int x) {
	if (cnc_last_z < down_pos) {
		fprintf(cncout_plugin_stream, "N%i G01 X%0.2f F%i\n", prog_num++, (float)x / 100.0, cnc_speed_xy);
	} else {
		fprintf(cncout_plugin_stream, "N%i G00 X%0.2f\n", prog_num++, (float)x / 100.0);
	}
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_y(int y) {
	if (cnc_last_z < down_pos) {
		fprintf(cncout_plugin_stream, "N%i G01 Y%0.2f F%i\n", prog_num++, (float)y / 100.0, cnc_speed_xy);
	} else {
		fprintf(cncout_plugin_stream, "N%i G00 Y%0.2f\n", prog_num++, (float)y / 100.0);
	}
	cnc_last_y = y;
	return 0;
}

int cncout_plugin_go_z(int z) {
	if (cnc_last_z != z) {
		fprintf(cncout_plugin_stream, "N%i G01 Z%0.2f F%i\n", prog_num++, (float)(z - down_pos) / 100.0, cnc_speed_z);
	}
	cnc_last_z = z;
	return 0;
}

int cncout_plugin_drill_on(void) {
	if (drill_speed_last != 100) {
		fprintf(cncout_plugin_stream, "N%i M3\n", prog_num++);
	}
	drill_speed_last = cnc_speed_default;
	return 0;
}

int cncout_plugin_drill_off(void) {
	if (drill_speed_last != 0) {
		fprintf(cncout_plugin_stream, "N%i M5\n", prog_num++);
	}
	drill_speed_last = 0;
	return 0;
}

int cncout_plugin_drill_set_speed(int speed) {
	if (speed != drill_speed_last) {
		if (speed == 0) {
			fprintf(cncout_plugin_stream, "N%i M5\n", prog_num++);
		} else {
			fprintf(cncout_plugin_stream, "N%i M3 S%i\n", prog_num++, speed * 35);
		}
	}
	drill_speed_last = speed;
	return 0;
}

int cncout_plugin_drill(void) {
	return 0;
}

int cncout_plugin_pen(int updown) {
	return 0;
}

int cncout_plugin_init(void) {
	cnc_last_updown = 0;
	cnc_last_x = 0;
	cnc_last_y = 0;
	cnc_last_z = 10000;
	cnc_speed_default = 10;
	cnc_speed_xy = cnc_speed_default;
	cnc_speed_z = cnc_speed_default;
	drill_speed_last = -1;
	prog_num = 0;
	return 0;
}

