
#include <linux/list.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <mntent.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>
#include <stdio.h>
#include <string.h> 
#include <dirent.h>
#include <dlfcn.h>
#include <math.h>

#include "config.h"
#include "serial.c"


int cnc_last_updown = 0;
int cnc_last_x = 0;
int cnc_last_y = 0;
int cnc_last_z = 0;
int cnc_tool_active = 0;
char serial_tty[256];

int sig[100][7];
int diffs[100];
int sig_max = 0;
char tool_name[100][128];
char new_sigstr[128];

typedef struct {
	int axis;
	int offset;
	float scale;
	float tolerance;
} mXm_Axis;

typedef struct {
	int axis;
	int offset_x;
	int offset_y;
	int offset_z;
	int offset_c;
	float scale;
	int size;
	int type;
	int tolerance;
	int motor;
} mXm_ToolAxis;

mXm_Axis mXm_XAxis;
mXm_Axis mXm_YAxis;
mXm_ToolAxis mXm_ZAxis[4];


int diff_int(int a, int b) {
	if (a == b) {
		return 0;
	} else if (a > b) {
		return a - b;
	} else {
		return b - a;
	}
	return 0;
}

float fak_int(int a, int b) {
	return (float)a / (float)b;
}

int cncout_plugin_get_offset_z(int tool_id) {
	if (tool_id == -1) {
		tool_id = cnc_tool_active;
	}
	return mXm_ZAxis[tool_id].offset_z;
}

int cncout_plugin_set_offset_z(int tool_id, int offset_z) {
	if (tool_id == -1) {
		tool_id = cnc_tool_active;
	}
	mXm_ZAxis[tool_id].offset_z = offset_z;
	return 0;
}

int cncout_plugin_check_z(void) {
	char tmp_str[512];
	char tmp_str2[512];

	serial_send("R2\n");
	sprintf(tmp_str, "A%i=%i\n", mXm_XAxis.axis, (int)((float)(mXm_ZAxis[cnc_tool_active].offset_x - 200) * mXm_XAxis.scale));
	serial_send(tmp_str);
	sprintf(tmp_str, "A%i=%i\n", mXm_YAxis.axis, (int)((float)(mXm_ZAxis[cnc_tool_active].offset_y) * mXm_YAxis.scale));
	serial_send(tmp_str);
	sprintf(tmp_str, "W%i\n", mXm_ZAxis[cnc_tool_active].axis);
	serial_send_receive(tmp_str, tmp_str2);
	mXm_ZAxis[cnc_tool_active].offset_z = (int)((float)(atoi(tmp_str2)) / mXm_ZAxis[cnc_tool_active].scale) + mXm_ZAxis[cnc_tool_active].offset_c;
	mXm_ZAxis[cnc_tool_active].tolerance = (int)((float)(atoi(strstr(tmp_str2, "\n") + 1)) / mXm_ZAxis[cnc_tool_active].scale);

// 	fprintf(stderr, "Tool Z-Offset: %0.2f mm\n", (float)mXm_ZAxis[cnc_tool_active].offset_z / 100.0);
// 	fprintf(stderr, "Z-Achsspiel: %0.2f mm\n", (float)mXm_ZAxis[cnc_tool_active].tolerance / 100.0);

	save_config();
	return mXm_ZAxis[cnc_tool_active].offset_z;
}

int cncout_plugin_check_size(void) {
	char tmp_str[512];
	char tmp_str2[512];
	int radius[10];
	int max_radius;
	int n = 0;
	int n2 = 0;

	char *loc;
	int tool_diff = 0;
	int tool_type = 0;
	int tolerance = 0;
	float FAK = (2 * 3.141592653589793 / 360.0);

	for (n2 = 0; n2 < sig_max; n2++) {
		diffs[n2] = 0;
	}
	max_radius = 0;
	new_sigstr[0] = 0;
	serial_send("R2\n");
	sprintf(tmp_str, "A%i=%i\n", mXm_XAxis.axis, (int)((float)(mXm_ZAxis[cnc_tool_active].offset_x - 200) * mXm_XAxis.scale));
	serial_send(tmp_str);
	sprintf(tmp_str, "A%i=%i\n", mXm_ZAxis[cnc_tool_active].axis, (int)((float)(mXm_ZAxis[cnc_tool_active].offset_z - mXm_ZAxis[cnc_tool_active].offset_c - 160) * mXm_ZAxis[cnc_tool_active].scale));
	serial_send(tmp_str);
	for (n = 0; n < 7; n++) {
		sprintf(tmp_str, "A%i=%i\n", mXm_YAxis.axis, (int)((float)(mXm_ZAxis[cnc_tool_active].offset_y - 200) * mXm_YAxis.scale));
		serial_send(tmp_str);
		sprintf(tmp_str, "A%i=%i\n", mXm_ZAxis[cnc_tool_active].axis, (int)((float)(mXm_ZAxis[cnc_tool_active].offset_z - mXm_ZAxis[cnc_tool_active].offset_c + (n * 50) + 10) * mXm_ZAxis[cnc_tool_active].scale));
		serial_send(tmp_str);
		sprintf(tmp_str, "w%i%i\n", mXm_YAxis.axis, mXm_ZAxis[cnc_tool_active].axis);
		serial_send_receive(tmp_str, tmp_str2);
		radius[n] = (int)(((float)(atoi(strstr(tmp_str2, "\n") + 1) - atoi(tmp_str2) - 54) / 2.0) / mXm_YAxis.scale);
		for (n2 = 0; n2 < sig_max; n2++) {
			diffs[n2] += diff_int(sig[n2][n], radius[n]);
		}
// 		fprintf(stderr, "Tool Radius: %0.2f mm (%0.2f mm on %0.1f mm)\n", (float)radius[n] / 100.0, (float)radius[n] / 100.0 * 2.0, (float)(n * 50) / 100.0);
		loc = strstr(tmp_str2, "\n") + 1;
		if (atoi(strstr(loc, "\n") + 1) > tolerance) {
			tolerance = atoi(strstr(loc, "\n") + 1);
		}
		if (radius[n] > max_radius) {
			max_radius = radius[n];
		}
		sprintf(tmp_str, "%i;", radius[n]);
		strcat(new_sigstr, tmp_str);
	}
	tool_type = 0;
	tool_diff = 20000;
	for (n = 0; n < 7; n++) {
		for (n2 = 0; n2 < sig_max; n2++) {
			if (diffs[n2] < tool_diff) {
				tool_type = n2;
				tool_diff = diffs[n2];
			}
		}
	}
	mXm_ZAxis[cnc_tool_active].offset_y = (int)((float)(atoi(tmp_str2) + ((atoi(strstr(tmp_str2, "\n") + 1) - atoi(tmp_str2)) / 2)) / mXm_YAxis.scale);
	mXm_ZAxis[cnc_tool_active].type = tool_type;
	mXm_ZAxis[cnc_tool_active].size = max_radius;
	mXm_YAxis.tolerance = (int)((float)tolerance / mXm_YAxis.scale);
// 	fprintf(stderr, "Tool-Type: %s (%i)\n", tool_name[mXm_ZAxis[cnc_tool_active].type], mXm_ZAxis[cnc_tool_active].type);
// 	fprintf(stderr, "Tool-Size: %0.2fmm\n", (float)mXm_ZAxis[cnc_tool_active].size * 2.0 / 100.0);
// 	fprintf(stderr, "Tool Y-Offset: %0.2f\n", (float)mXm_ZAxis[cnc_tool_active].offset_y / 100.0);
// 	fprintf(stderr, "Y-Achsspiel: %0.2f mm\n", (float)mXm_YAxis.tolerance / 100.0);
	if (tool_diff > 30) {
		strcat(new_sigstr, "NewTool");
	} else {
		strcat(new_sigstr, tool_name[mXm_ZAxis[cnc_tool_active].type]);
	}
	fprintf(stderr, "SIGNATURE: %s\n", new_sigstr);

	save_config();
	return max_radius;
}

int load_signature(void) {
	FILE *stream;
	char read_line[256];
	char *loc1;
	char *loc2;
	sig_max = 0;
	if ((stream = fopen("/usr/src/2D-Draw/src/tools.sig", "r")) != 0) {
		while(!feof(stream)) {
			read_line[0] = 0;
			fgets(read_line, 255, stream);
			if ((int)(loc1 = strstr(read_line, ";") + 1) != 1) {
				sig[sig_max][1] = atoi(loc1);
				loc2 = strstr(loc1, ";") + 1;
				sig[sig_max][2] = atoi(loc2);
				loc1 = strstr(loc2, ";") + 1;
				sig[sig_max][3] = atoi(loc1);
				loc2 = strstr(loc1, ";") + 1;
				sig[sig_max][4] = atoi(loc2);
				loc1 = strstr(loc2, ";") + 1;
				sig[sig_max][5] = atoi(loc1);
				loc2 = strstr(loc1, ";") + 1;
				sig[sig_max][6] = atoi(loc2);
				loc1 = strstr(loc2, ";") + 1;
				strcpy(tool_name[sig_max], loc1);
				tool_name[sig_max][strlen(tool_name[sig_max]) - 1] = 0;
// 				fprintf(stderr, "Tool-Signature(%i): %s\n", sig_max, tool_name[sig_max]);
				sig_max++;
			}
		}
		fclose(stream);
	}
	return 0;
}

int cncout_plugin_autosetup(void) {
	cncout_plugin_reset();
	cncout_plugin_check_z();
	cncout_plugin_check_size();
	serial_send("R2\n");
	cncout_plugin_off();
	return 0;
}

int cncout_plugin_set_speed_xy(int speed) {
	char cmd[25];
	sprintf(cmd, "S%i=%i\n", mXm_XAxis.axis, speed);
	serial_send(cmd);
	sprintf(cmd, "S%i=%i\n", mXm_YAxis.axis, speed);
	serial_send(cmd);
	return 0;
}

int cncout_plugin_set_speed_z(int speed) {
	char cmd[25];
	sprintf(cmd, "S%i=%i\n", mXm_ZAxis[cnc_tool_active].axis, speed);
	serial_send(cmd);
	return 0;
}

int cncout_plugin_soft_start(int value) {
	char cmd[25];
	sprintf(cmd, "F=%i\n", value);
	serial_send(cmd);
	return 0;
}

int cncout_plugin_reset(void) {
	char cmd[6];
	sprintf(cmd, "R%i\n", mXm_ZAxis[0].axis);
	serial_send(cmd);
	sprintf(cmd, "R%i\n", mXm_ZAxis[1].axis);
	serial_send(cmd);
	sprintf(cmd, "R%i\n", mXm_XAxis.axis);
	serial_send(cmd);
	sprintf(cmd, "R%i\n", mXm_YAxis.axis);
	serial_send(cmd);
	return 0;
}

int cncout_plugin_start(int x, int y, int z, int r) {
	cncout_plugin_set_speed_xy(255);
	cncout_plugin_set_speed_z(255);
	return 0;
}

int cncout_plugin_stop(void) {
	cncout_plugin_set_speed_xy(255);
	cncout_plugin_set_speed_z(255);
	cncout_plugin_go_z(mXm_ZAxis[cnc_tool_active].offset_z);
	cncout_plugin_drill_off();
	cncout_plugin_go_xy(0, 0);
	cncout_plugin_off();
	return 0;
}

int cncout_plugin_off(void) {
	serial_send("O\n");
	return 0;
}

int cncout_plugin_tool_change(int tool_nr) {
	cncout_plugin_set_speed_xy(255);
	cncout_plugin_go_z(mXm_ZAxis[cnc_tool_active].offset_z);
	cncout_plugin_drill_off();
	cnc_tool_active = tool_nr;
	cncout_plugin_go_z(mXm_ZAxis[cnc_tool_active].offset_z);
	cncout_plugin_drill_off();
	return 0;
}

int cncout_plugin_go_xy(int x, int y) {
	char cmd[256];
	if (cnc_last_x != x || cnc_last_y != y) {
		sprintf(cmd, "A%i=%i,%i=%i\n", mXm_XAxis.axis, (int)((float)(x + mXm_ZAxis[cnc_tool_active].offset_x + mXm_XAxis.offset) * mXm_XAxis.scale), mXm_YAxis.axis, (int)((float)(y + mXm_ZAxis[cnc_tool_active].offset_y + mXm_YAxis.offset) * mXm_YAxis.scale));
		serial_send(cmd);
	}
	cnc_last_y = y;
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_xyz(int x, int y, int z) {
	char cmd[256];
	if (cnc_last_x != x || cnc_last_y != y || cnc_last_z != z) {
		sprintf(cmd, "A%i=%i,%i=%i,%i=%i\n", mXm_XAxis.axis, (int)((float)(x + mXm_ZAxis[cnc_tool_active].offset_x + mXm_XAxis.offset) * mXm_XAxis.scale), mXm_YAxis.axis, (int)((float)(y + mXm_ZAxis[cnc_tool_active].offset_y + mXm_YAxis.offset) * mXm_XAxis.scale), (int)((float)(mXm_ZAxis[cnc_tool_active].offset_z - z) * mXm_ZAxis[cnc_tool_active].scale));
		serial_send(cmd);
	}
	cnc_last_y = y;
	cnc_last_x = x;
	cnc_last_z = z;
	return 0;
}

int cncout_plugin_go_x(int x) {
	char cmd[256];
	sprintf(cmd, "A%i=%i\n", mXm_XAxis.axis, (int)((float)(x + mXm_ZAxis[cnc_tool_active].offset_x + mXm_XAxis.offset) * mXm_XAxis.scale));
	serial_send(cmd);
	cnc_last_x = x;
	return 0;
}

int cncout_plugin_go_y(int y) {
	char cmd[256];
	sprintf(cmd, "A%i=%i\n", mXm_YAxis.axis, (int)((float)(y + mXm_ZAxis[cnc_tool_active].offset_y + mXm_YAxis.offset) * mXm_XAxis.scale));
	serial_send(cmd);
	cnc_last_y = y;
	return 0;
}

int cncout_plugin_go_z(int pos_z) {
	char cmd[256];
	sprintf(cmd, "A%i=%i\n", mXm_ZAxis[cnc_tool_active].axis, (int)((float)(mXm_ZAxis[cnc_tool_active].offset_z - pos_z) * mXm_ZAxis[cnc_tool_active].scale));
	serial_send(cmd);
	cnc_last_z = pos_z;
	return 0;
}

int cncout_plugin_drill_on(void) {
	char cmd[256];
	sprintf(cmd, "M%i=%i\n", mXm_ZAxis[cnc_tool_active].motor, 255);
	serial_send(cmd);
	return 0;
}

int cncout_plugin_drill_off(void) {
	char cmd[256];
	sprintf(cmd, "M%i=%i\n", mXm_ZAxis[cnc_tool_active].motor, 0);
	serial_send(cmd);
	return 0;
}

int cncout_plugin_drill_set_speed(int speed) {
	char cmd[256];
	sprintf(cmd, "M%i=%i\n", mXm_ZAxis[cnc_tool_active].motor, (int)((float)speed * 2.55));
	serial_send(cmd);
	return 0;
}

int cncout_plugin_drill(void) {
	return 0;
}

int cncout_plugin_pen(int updown) {
	return 0;
}

int load_config(void) {
	FILE *stream;
	char read_line[256];
	if ((stream = fopen("/etc/mxm-cnc.cfg", "r")) != 0) {
		while(!feof(stream)) {
			read_line[0] = 0;
			fgets(read_line, 255, stream);
			if (strncmp(read_line, "TOOL_ACTIVE=", 12) == 0) {
				cnc_tool_active = atoi(read_line + 12);
			} else if (strncmp(read_line, "SERIAL_TTY=", 11) == 0) {
				strcpy(serial_tty, read_line + 11);
				serial_tty[strlen(serial_tty) - 1] = 0;
			} else if (strncmp(read_line, "X_AXIS_SCALE=", 13) == 0) {
				mXm_XAxis.scale = atof(read_line + 13);
			} else if (strncmp(read_line, "X_AXIS_NUM=", 11) == 0) {
				mXm_XAxis.axis = atoi(read_line + 11);
			} else if (strncmp(read_line, "X_AXIS_OFFSET=", 14) == 0) {
				mXm_XAxis.offset = atoi(read_line + 14);
			} else if (strncmp(read_line, "Y_AXIS_SCALE=", 13) == 0) {
				mXm_YAxis.scale = atof(read_line + 13);
			} else if (strncmp(read_line, "Y_AXIS_NUM=", 11) == 0) {
				mXm_YAxis.axis = atoi(read_line + 11);
			} else if (strncmp(read_line, "Y_AXIS_OFFSET=", 14) == 0) {
				mXm_YAxis.offset = atoi(read_line + 14);

			} else if (strncmp(read_line, "Z_AXIS0_SCALE=", 14) == 0) {
				mXm_ZAxis[0].scale = atof(read_line + 14);
			} else if (strncmp(read_line, "Z_AXIS0_NUM=", 12) == 0) {
				mXm_ZAxis[0].axis = atoi(read_line + 12);
			} else if (strncmp(read_line, "Z_AXIS0_OFFSET_X=", 17) == 0) {
				mXm_ZAxis[0].offset_x = atoi(read_line + 17);
			} else if (strncmp(read_line, "Z_AXIS0_OFFSET_Y=", 17) == 0) {
				mXm_ZAxis[0].offset_y = atoi(read_line + 17);
			} else if (strncmp(read_line, "Z_AXIS0_OFFSET_Z=", 17) == 0) {
				mXm_ZAxis[0].offset_z = atoi(read_line + 17);
			} else if (strncmp(read_line, "Z_AXIS0_OFFSET_C=", 17) == 0) {
				mXm_ZAxis[0].offset_c = atoi(read_line + 17);
			} else if (strncmp(read_line, "Z_AXIS0_SIZE=", 13) == 0) {
				mXm_ZAxis[0].size = atoi(read_line + 13);
			} else if (strncmp(read_line, "Z_AXIS0_TYPE=", 13) == 0) {
				mXm_ZAxis[0].type = atoi(read_line + 13);
			} else if (strncmp(read_line, "Z_AXIS0_MOTOR=", 14) == 0) {
				mXm_ZAxis[0].motor = atoi(read_line + 14);
			} else if (strncmp(read_line, "Z_AXIS0_TOLERANCE=", 18) == 0) {
				mXm_ZAxis[0].tolerance = atoi(read_line + 18);

			} else if (strncmp(read_line, "Z_AXIS1_SCALE=", 14) == 0) {
				mXm_ZAxis[1].scale = atof(read_line + 14);
			} else if (strncmp(read_line, "Z_AXIS1_NUM=", 12) == 0) {
				mXm_ZAxis[1].axis = atoi(read_line + 12);
			} else if (strncmp(read_line, "Z_AXIS1_OFFSET_X=", 17) == 0) {
				mXm_ZAxis[1].offset_x = atoi(read_line + 17);
			} else if (strncmp(read_line, "Z_AXIS1_OFFSET_Y=", 17) == 0) {
				mXm_ZAxis[1].offset_y = atoi(read_line + 17);
			} else if (strncmp(read_line, "Z_AXIS1_OFFSET_Z=", 17) == 0) {
				mXm_ZAxis[1].offset_z = atoi(read_line + 17);
			} else if (strncmp(read_line, "Z_AXIS1_OFFSET_C=", 17) == 0) {
				mXm_ZAxis[1].offset_c = atoi(read_line + 17);
			} else if (strncmp(read_line, "Z_AXIS1_SIZE=", 13) == 0) {
				mXm_ZAxis[1].size = atoi(read_line + 13);
			} else if (strncmp(read_line, "Z_AXIS1_TYPE=", 13) == 0) {
				mXm_ZAxis[1].type = atoi(read_line + 13);
			} else if (strncmp(read_line, "Z_AXIS1_MOTOR=", 14) == 0) {
				mXm_ZAxis[1].motor = atoi(read_line + 14);
			} else if (strncmp(read_line, "Z_AXIS1_TOLERANCE=", 18) == 0) {
				mXm_ZAxis[1].tolerance = atoi(read_line + 18);
			}
		}
		fclose(stream);
	} else {
		return 1;
	}
	return 0;
}

int save_config(void) {
	FILE *stream;
	char read_line[256];
	if ((stream = fopen("/etc/mxm-cnc.cfg", "w")) != 0) {
		fprintf(stream, "\n");
		fprintf(stream, "//Serial-Device:\n");
		fprintf(stream, "SERIAL_TTY=%s\n", serial_tty);
		fprintf(stream, "\n");
		fprintf(stream, "//Active Tool:\n");
		fprintf(stream, "TOOL_ACTIVE=%i\n", cnc_tool_active);
		fprintf(stream, "\n");
		fprintf(stream, "//X-Axis:\n");
		fprintf(stream, "X_AXIS_SCALE=%0.2f (steps/0.01mm)\n", mXm_XAxis.scale);
		fprintf(stream, "X_AXIS_NUM=%i (Interface-Number of the Axis)\n", mXm_XAxis.axis);
		fprintf(stream, "X_AXIS_OFFSET=%i (Offset in 100/mm)\n", mXm_XAxis.offset);
		fprintf(stream, "\n");
		fprintf(stream, "//Y-Axis:\n");
		fprintf(stream, "Y_AXIS_SCALE=%0.2f\n", mXm_YAxis.scale);
		fprintf(stream, "Y_AXIS_NUM=%i\n", mXm_YAxis.axis);
		fprintf(stream, "Y_AXIS_OFFSET=%i\n", mXm_YAxis.offset);
		fprintf(stream, "\n");
		fprintf(stream, "//1. Z-Axis:\n");
		fprintf(stream, "Z_AXIS0_SCALE=%0.2f\n", mXm_ZAxis[0].scale);
		fprintf(stream, "Z_AXIS0_NUM=%i\n", mXm_ZAxis[0].axis);
		fprintf(stream, "Z_AXIS0_OFFSET_X=%i    (X-Offset-Correction in 100/mm)\n", mXm_ZAxis[0].offset_x);
		fprintf(stream, "Z_AXIS0_OFFSET_Y=%i (Y-Offset-Correction in 100/mm)\n", mXm_ZAxis[0].offset_y);
		fprintf(stream, "Z_AXIS0_OFFSET_Z=%i (Z-Offset-Correction in 100/mm)\n", mXm_ZAxis[0].offset_z);
		fprintf(stream, "Z_AXIS0_OFFSET_C=%i  (Z-Check-Offset-Correction in 100/mm)\n", mXm_ZAxis[0].offset_c);
		fprintf(stream, "Z_AXIS0_SIZE=%i      (Tool-Radius 100/mm)\n", mXm_ZAxis[0].size);
		fprintf(stream, "Z_AXIS0_TYPE=%i        (Tool-Type / %s)\n", mXm_ZAxis[0].type, tool_name[mXm_ZAxis[0].type]);
		fprintf(stream, "Z_AXIS0_MOTOR=%i       (Interface-ID)\n", mXm_ZAxis[0].motor);
		fprintf(stream, "Z_AXIS0_TOLERANCE=%i  (Spindel-Tolerance in 100/mm)\n", mXm_ZAxis[0].tolerance);
		fprintf(stream, "\n");
		fprintf(stream, "//2. Z-Axis:\n");
		fprintf(stream, "Z_AXIS1_SCALE=%0.2f\n", mXm_ZAxis[1].scale);
		fprintf(stream, "Z_AXIS1_NUM=%i\n", mXm_ZAxis[1].axis);
		fprintf(stream, "Z_AXIS1_OFFSET_X=%i\n", mXm_ZAxis[1].offset_x);
		fprintf(stream, "Z_AXIS1_OFFSET_Y=%i\n", mXm_ZAxis[1].offset_y);
		fprintf(stream, "Z_AXIS1_OFFSET_Z=%i\n", mXm_ZAxis[1].offset_z);
		fprintf(stream, "Z_AXIS1_OFFSET_C=%i\n", mXm_ZAxis[1].offset_c);
		fprintf(stream, "Z_AXIS1_SIZE=%i\n", mXm_ZAxis[1].size);
		fprintf(stream, "Z_AXIS1_TYPE=%i (%s)\n", mXm_ZAxis[1].type, tool_name[mXm_ZAxis[1].type]);
		fprintf(stream, "Z_AXIS1_MOTOR=%i\n", mXm_ZAxis[1].motor);
		fprintf(stream, "Z_AXIS1_TOLERANCE=%i\n", mXm_ZAxis[1].tolerance);
		fprintf(stream, "\n");
		fclose(stream);
	} else {
		return 1;
	}
	return 0;
}

int cncout_plugin_init(void) {
	cnc_last_updown = 0;
	cnc_last_x = 0;
	cnc_last_y = 0;
	cnc_last_z = 0;
	cnc_tool_active = 0;

	mXm_XAxis.scale = 2.5;
	mXm_XAxis.axis = 0;
	mXm_XAxis.offset = 4000;
	mXm_YAxis.scale = 2.5;
	mXm_YAxis.axis = 1;
	mXm_YAxis.offset = 6000;
	mXm_ZAxis[0].scale = 0.6;
	mXm_ZAxis[0].axis = 2;
	mXm_ZAxis[0].offset_x = 0;
	mXm_ZAxis[0].offset_y = 4206;
	mXm_ZAxis[0].offset_z = 4900;
	mXm_ZAxis[0].offset_c = 272;
	mXm_ZAxis[0].motor = 0;
	mXm_ZAxis[1].scale = 0.6;
	mXm_ZAxis[1].axis = 4;
	mXm_ZAxis[1].offset_x = 0;
	mXm_ZAxis[1].offset_y = 200;
	mXm_ZAxis[1].offset_z = 4900;
	mXm_ZAxis[1].offset_c = 272;
	mXm_ZAxis[1].motor = 1;
	strcpy(serial_tty, "/dev/ttyS1");
	if (load_config() != 0) {
		fprintf(stderr, "Error while loading Configuration-File: %s\n", "/etc/mxm-cnc.cfg");
		return 1;
	}
	load_signature();
	if (serial_open(serial_tty) != 0) {
		fprintf(stderr, "Error while opening Serial-Device: %s\n", serial_tty);
		return 1;
	}
	return 0;
}

int cncout_plugin_cfgfe_show(void) {
	system("cnc-config /etc/mxm-cnc.cfg &");
	return 0;
}

int cncout_plugin_cfgfe_hide(void) {
	system("killall cnc-config");
	return 0;
}
