
#include <linux/list.h>
#include <sys/signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <mntent.h>
#include <termios.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libgen.h>
#include <time.h>
#include <unistd.h>
#include <dirent.h>
#include <stdio.h>


#include "cnc-output_mxm.c"


int main(int argc, char *argv[]) {
	char cmd_str[128];
	char rep_str[512];
	if (cncout_plugin_init() == 0) {
		if (argc == 1) {
			fprintf(stderr, "\n");
			fprintf(stderr, "USAGE:\n");
			fprintf(stderr, "	mxm_send [-r|-o|-w|-s|-S|-a|MXM_CMD]\n");
			fprintf(stderr, "\n");
			return 1;
		} else if (argc == 2 && strcmp(argv[1] , "-r") == 0) {
			cncout_plugin_reset();
		} else if (argc == 2 && strcmp(argv[1] , "-o") == 0) {
			cncout_plugin_off();
		} else if (argc == 2 && strcmp(argv[1] , "-w") == 0) {
			cncout_plugin_check_z();
			fprintf(stderr, "\n");
			fprintf(stderr, "Tool-Type: %s (%i)\n", tool_name[mXm_ZAxis[cnc_tool_active].type], mXm_ZAxis[cnc_tool_active].type);
			fprintf(stderr, "Tool-Size: %0.2fmm\n", (float)mXm_ZAxis[cnc_tool_active].size * 2.0 / 100.0);
			fprintf(stderr, "Y-Offset: %0.2f\n", (float)mXm_ZAxis[cnc_tool_active].offset_y / 100.0);
			fprintf(stderr, "Z-Offset: %0.2f mm\n", (float)mXm_ZAxis[cnc_tool_active].offset_z / 100.0);
			fprintf(stderr, "Y-Achsspiel: %0.2f mm\n", (float)mXm_YAxis.tolerance / 100.0);
			fprintf(stderr, "Z-Achsspiel: %0.2f mm\n", (float)mXm_ZAxis[cnc_tool_active].tolerance / 100.0);
			fprintf(stderr, "\n");
		} else if (argc == 2 && strcmp(argv[1] , "-s") == 0) {
			cncout_plugin_check_size();
			fprintf(stderr, "\n");
			fprintf(stderr, "Tool-Type: %s (%i)\n", tool_name[mXm_ZAxis[cnc_tool_active].type], mXm_ZAxis[cnc_tool_active].type);
			fprintf(stderr, "Tool-Size: %0.2fmm\n", (float)mXm_ZAxis[cnc_tool_active].size * 2.0 / 100.0);
			fprintf(stderr, "Y-Offset: %0.2f\n", (float)mXm_ZAxis[cnc_tool_active].offset_y / 100.0);
			fprintf(stderr, "Z-Offset: %0.2f mm\n", (float)mXm_ZAxis[cnc_tool_active].offset_z / 100.0);
			fprintf(stderr, "Y-Achsspiel: %0.2f mm\n", (float)mXm_YAxis.tolerance / 100.0);
			fprintf(stderr, "Z-Achsspiel: %0.2f mm\n", (float)mXm_ZAxis[cnc_tool_active].tolerance / 100.0);
			fprintf(stderr, "\n");
		} else if (argc == 2 && strcmp(argv[1] , "-S") == 0) {
			cncout_plugin_autosetup();
			fprintf(stderr, "\n");
			fprintf(stderr, "Tool-Type: %s (%i)\n", tool_name[mXm_ZAxis[cnc_tool_active].type], mXm_ZAxis[cnc_tool_active].type);
			fprintf(stderr, "Tool-Size: %0.2fmm\n", (float)mXm_ZAxis[cnc_tool_active].size * 2.0 / 100.0);
			fprintf(stderr, "Y-Offset: %0.2f\n", (float)mXm_ZAxis[cnc_tool_active].offset_y / 100.0);
			fprintf(stderr, "Z-Offset: %0.2f mm\n", (float)mXm_ZAxis[cnc_tool_active].offset_z / 100.0);
			fprintf(stderr, "Y-Achsspiel: %0.2f mm\n", (float)mXm_YAxis.tolerance / 100.0);
			fprintf(stderr, "Z-Achsspiel: %0.2f mm\n", (float)mXm_ZAxis[cnc_tool_active].tolerance / 100.0);
			fprintf(stderr, "\n");
		} else if (argc == 2 && strcmp(argv[1] , "-a") == 0) {
// 			cncout_plugin_autosetup();
			cncout_plugin_check_z();
			cncout_plugin_check_size();
			fprintf(stderr, "\n");
			fprintf(stderr, "Tool-Type: %s (%i)\n", tool_name[mXm_ZAxis[cnc_tool_active].type], mXm_ZAxis[cnc_tool_active].type);
			fprintf(stderr, "Tool-Size: %0.2fmm\n", (float)mXm_ZAxis[cnc_tool_active].size * 2.0 / 100.0);
			fprintf(stderr, "\n");
			sprintf(cmd_str, "echo \"%s\" >> /usr/src/2D-Draw/src/tools.sig\n", new_sigstr);
			system(cmd_str);
		} else if (argc == 3 && strcmp(argv[1] , "-x") == 0) {
			cncout_plugin_go_x(atoi(argv[2]));
		} else if (argc == 3 && strcmp(argv[1] , "-y") == 0) {
			cncout_plugin_go_y(atoi(argv[2]));
		} else if (argc == 3 && strcmp(argv[1] , "-z") == 0) {
			cncout_plugin_go_z(atoi(argv[2]));
		} else if (argc == 4 && strcmp(argv[1] , "-xy") == 0) {
			cncout_plugin_go_xy(atoi(argv[2]), atoi(argv[3]));
		} else if (argc == 5 && strcmp(argv[1] , "-xyz") == 0) {
			cncout_plugin_go_xyz(atoi(argv[2]), atoi(argv[3]), atoi(argv[4]));
		} else if (argc == 2) {
			rep_str[0] = 0;
			sprintf(cmd_str, "%s\n", argv[1]);
			serial_send_receive(cmd_str, rep_str);
			fprintf(stderr, "%s\n", rep_str);
		}
	} else {
		return 1;
	}
	return 0;
}

